/**
 * 通用js方法封装处理
 * Copyright (c) 2019 ruoyi
 */

// 日期格式化
export function parseTime(time, pattern) {
    if (arguments.length === 0 || !time) {
        return null;
    }
    const format = pattern || '{y}-{m}-{d} {h}:{i}:{s}';
    let date;
    if (typeof time === 'object') {
        date = time;
    } else {
        if (typeof time === 'string' && /^[0-9]+$/.test(time)) {
            // eslint-disable-next-line no-param-reassign
            time = parseInt(time, 10);
        } else if (typeof time === 'string') {
            // eslint-disable-next-line no-param-reassign
            time = time
                // eslint-disable-next-line prefer-regex-literals
                .replace(new RegExp(/-/gm), '/')
                .replace('T', ' ')
                // eslint-disable-next-line prefer-regex-literals
                .replace(new RegExp(/\.[\d]{3}/gm), '');
        }
        if (typeof time === 'number' && time.toString().length === 10) {
            // eslint-disable-next-line no-param-reassign
            time *= 1000;
        }
        date = new Date(time);
    }
    const formatObj = {
        y: date.getFullYear(),
        m: date.getMonth() + 1,
        d: date.getDate(),
        h: date.getHours(),
        i: date.getMinutes(),
        s: date.getSeconds(),
        a: date.getDay(),
    };
    const timeStr = format.replace(/{(y|m|d|h|i|s|a)+}/g, (result, key) => {
        let value = formatObj[key];
        // Note: getDay() returns 0 on Sunday
        if (key === 'a') {
            return ['日', '一', '二', '三', '四', '五', '六'][value];
        }
        if (result.length > 0 && value < 10) {
            value = `0${value}`;
        }
        return value || 0;
    });
    return timeStr;
}

// 表单重置
export function resetForm(refName) {
    if (this.$refs[refName]) {
        this.$refs[refName].resetFields();
    }
}

// 添加日期范围
export function addDateRange(params, dateRange, propName) {
    const search = params;
    search.params = typeof search.params === 'object' && search.params !== null && !Array.isArray(search.params) ? search.params : {};
    // eslint-disable-next-line no-param-reassign
    dateRange = Array.isArray(dateRange) ? dateRange : [];
    if (typeof propName === 'undefined') {
        // eslint-disable-next-line prefer-destructuring
        search.params.beginTime = dateRange[0];
        // eslint-disable-next-line prefer-destructuring
        search.params.endTime = dateRange[1];
    } else {
        // eslint-disable-next-line prefer-destructuring
        search.params[`begin${propName}`] = dateRange[0];
        // eslint-disable-next-line prefer-destructuring
        search.params[`end${propName}`] = dateRange[1];
    }
    return search;
}

// 回显数据字典
export function selectDictLabel(datas, value) {
    if (value === undefined) {
        return '';
    }
    const actions = [];
    Object.keys(datas).some((key) => {
        if (datas[key].value === `${value}`) {
            actions.push(datas[key].label);
            return true;
        }
    });
    if (actions.length === 0) {
        actions.push(value);
    }
    return actions.join('');
}

// 回显数据字典（字符串数组）
export function selectDictLabels(datas, value, separator) {
    if (value === undefined || value.length === 0) {
        return '';
    }
    if (Array.isArray(value)) {
        // eslint-disable-next-line no-param-reassign
        value = value.join(',');
    }
    const actions = [];
    const currentSeparator = undefined === separator ? ',' : separator;
    const temp = value.split(currentSeparator);
    Object.keys(value.split(currentSeparator)).some((val) => {
        let match = false;
        Object.keys(datas).some((key) => {
            if (datas[key].value == `${temp[val]}`) {
                actions.push(datas[key].label + currentSeparator);
                match = true;
            }
        });
        if (!match) {
            actions.push(temp[val] + currentSeparator);
        }
    });
    return actions.join('').substring(0, actions.join('').length - 1);
}

// 字符串格式化(%s )
export function sprintf(str) {
    const args = arguments;
    let flag = true;
    let i = 1;
    str = str.replace(/%s/g, function () {
        const arg = args[i++];
        if (typeof arg === 'undefined') {
            flag = false;
            return '';
        }
        return arg;
    });
    return flag ? str : '';
}

// 转换字符串，undefined,null等转化为""
export function parseStrEmpty(str) {
    if (!str || str == 'undefined' || str == 'null') {
        return '';
    }
    return str;
}

// 数据合并
export function mergeRecursive(source, target) {
    // eslint-disable-next-line guard-for-in,no-restricted-syntax
    for (const p in target) {
        try {
            if (target[p].constructor === Object) {
                // eslint-disable-next-line no-param-reassign
                source[p] = mergeRecursive(source[p], target[p]);
            } else {
                // eslint-disable-next-line no-param-reassign
                source[p] = target[p];
            }
        } catch (e) {
            // eslint-disable-next-line no-param-reassign
            source[p] = target[p];
        }
    }
    return source;
}

/**
 * 构造树型结构数据
 * @param {*} data 数据源
 * @param {*} id id字段 默认 'id'
 * @param {*} parentId 父节点字段 默认 'parentId'
 * @param {*} children 孩子节点字段 默认 'children'
 */
export function handleTree(data, id, parentId, children) {
    const config = {
        id: id || 'id',
        parentId: parentId || 'pid',
        childrenList: children || 'children',
    };

    const childrenListMap = {};
    const nodeIds = {};
    const tree = [];

    // eslint-disable-next-line no-restricted-syntax
    for (const d of data) {
        // eslint-disable-next-line no-shadow
        const parentId = d[config.parentId];
        if (childrenListMap[parentId] == null) {
            childrenListMap[parentId] = [];
        }
        nodeIds[d[config.id]] = d;
        childrenListMap[parentId].push(d);
    }

    // eslint-disable-next-line no-restricted-syntax
    for (const d of data) {
        // eslint-disable-next-line no-shadow
        const parentId = d[config.parentId];
        if (nodeIds[parentId] == null) {
            tree.push(d);
        }
    }

    // eslint-disable-next-line no-restricted-syntax
    for (const t of tree) {
        // eslint-disable-next-line no-use-before-define
        adaptToChildrenList(t);
    }

    function adaptToChildrenList(o) {
        if (childrenListMap[o[config.id]] !== null) {
            // eslint-disable-next-line no-param-reassign
            o[config.childrenList] = childrenListMap[o[config.id]];
        }
        if (o[config.childrenList]) {
            // eslint-disable-next-line no-restricted-syntax
            for (const c of o[config.childrenList]) {
                adaptToChildrenList(c);
            }
        }
    }

    return tree;
}

/**
 * 参数处理
 * @param {*} params  参数
 */
export function tansParams(params) {
    let result = '';
    // eslint-disable-next-line no-restricted-syntax
    for (const propName of Object.keys(params)) {
        const value = params[propName];
        const part = `${encodeURIComponent(propName)}=`;
        if (value !== null && value !== '' && typeof value !== 'undefined') {
            if (typeof value === 'object') {
                // eslint-disable-next-line no-restricted-syntax
                for (const key of Object.keys(value)) {
                    if (value[key] !== null && value[key] !== '' && typeof value[key] !== 'undefined') {
                        // eslint-disable-next-line no-shadow
                        const params = `${propName}[${key}]`;
                        const subPart = `${encodeURIComponent(params)}=`;
                        result += `${subPart + encodeURIComponent(value[key])}&`;
                    }
                }
            } else {
                result += `${part + encodeURIComponent(value)}&`;
            }
        }
    }
    return result;
}

// 返回项目路径
export function getNormalPath(p) {
    if (p.length === 0 || !p || p == 'undefined') {
        return p;
    }

    const res = p.replace('//', '/');
    if (res[res.length - 1] === '/') {
        return res.slice(0, res.length - 1);
    }
    return res;
}

// 验证是否为blob格式
export function blobValidate(data) {
    return data.type !== 'application/json';
}

// 扫描二维码获取设备id过滤
export function getDeviceId(url) {
    let size = '';
    // 2406501594
    if (!isNaN(Number(url))) {
        size = url;
    } else if (url.indexOf('/jbq/') != -1) {
        // https://iot.aiotagro.com/jbq/2406501594
        size = url.split('/jbq/')[url.split('/jbq/').length - 1];
    } else if (url.indexOf('device_sn') != -1) {
        // https://farm.aiotagro.com/source/index.html？devicesn=2408400279&嚓te&t=1730775527

        const parsedUrl = new URL(url);
        size = parsedUrl.searchParams.get('device_sn');
        // https://farm.aiotagro.com/source/index.html?device_sn=2408400301
        // size = url.split('devicesn=')[url.split('devicesn=').length-1]
    } else {
        return '';
    }
    return size;
}
